import ddf.minim.spi.*;
import ddf.minim.signals.*;
import ddf.minim.*;
import ddf.minim.analysis.*;
import ddf.minim.ugens.*;
import ddf.minim.effects.*;

final float maxGridX = 16;
final float maxGridY = 9;
int GAME_STATE = 0;
int remainingMoves = 24;
int remainingEnemies;
float fadeCount = 0;

Minim minim;
AudioPlayer playerTick;
AudioPlayer playerWhistle;
AudioPlayer playerSong;
AudioPlayer playerBip;
AudioPlayer playerBew;
int leaveCredits = 0;
boolean gridSelected = false;
boolean doneText = false;
boolean mainFade = false;
int mainFadeNum = 0;
int selectedGridX = -1;
int selectedGridY = -1;
int destinationX;
int destinationY;
float offsetX = 0;
float offsetY = 0;
float gridX = 16;
float gridY = 9;
float gridSizeX;
float gridSizeY;
int tempGridX = -1;
int tempGridY = -1;
int mainMenu = 0;
int dIndex = 0;
int n = 0;
GridObject[][] objects = new GridObject[(int)maxGridX][(int)maxGridY];
Menu menu = new Menu();
WheelKnight skeleton;
GridObject tempObject;
Dialogue[] dialogues = new Dialogue[39];
PImage grass;
PImage rock;
PImage demon;
PImage berserkerHead;
PImage berserkerSprite;
PImage skullHead;
PImage skullSprite;
PImage healerHead;
PImage healerSprite;
PImage wizardHead;
PImage wizardSprite;
PImage bub;
PImage logo;
PImage textBox;
PImage textBack;
PImage headBox;
PImage headBack;
PImage arrowUp;
PImage arrowDown;
PImage arrowLeft;
PImage arrowRight;
PImage narrator;
PImage heroGroup;
PImage heroGroup2;
PImage buttonPlay;
PImage buttonCredits;
PImage buttonIntro;
PImage title;
PImage credits;

void setup() {
  size(displayWidth, displayHeight);
  frameRate(60);
  minim = new Minim(this);
  playerWhistle = minim.loadFile("whistle.wav");
  playerSong = minim.loadFile("click.wav");
  playerTick = minim.loadFile("tock.wav");
  playerBip = minim.loadFile("bip.wav");
  playerBew = minim.loadFile("bew.wav");
  logo = loadImage("logo.png");
  heroGroup = loadImage("young_heroes.png");
  heroGroup2 = loadImage("old_heroes.png");  
  credits = requestImage("DSC_0148.png");
  grass = requestImage("grass.png");
  rock = requestImage("rock.png");
  demon = requestImage("minion.png");
  berserkerHead = requestImage("b2.png");
  berserkerSprite = requestImage("berserker_SPRITE.png");
  skullHead = requestImage("skull.png");
  skullSprite = requestImage("skull_SPRITE.png");
  healerHead = requestImage("healer.png");
  healerSprite = requestImage("healer_SPrite.png");
  wizardHead = requestImage("wizard.png");
  wizardSprite = requestImage("wizard_SPRITE.png");
  bub = requestImage("bubaloobi.png");
  textBox = requestImage("textbox.png");
  textBack = requestImage("textbox_back.png");
  headBox = requestImage("frame.png");
  headBack = requestImage("frame_back.png");
  arrowUp = requestImage("arrow_u.png");
  arrowDown = requestImage("arrow_d.png");
  arrowLeft = requestImage("arrow_l.png");
  arrowRight = requestImage("arrow_r.png");
  narrator = requestImage("narrator.png");
  title = requestImage("title.png");
  buttonPlay = requestImage("button1_PG.png");
  buttonIntro = requestImage("button2_WI.png");
  buttonCredits = requestImage("button3_C.png");
  int r;
  int r2;
  while (true)
  {
    r = (int)random(maxGridX);
    r2 = (int)random(maxGridY);

    if (objects[r][r2] == null)
    {
      new WheelKnight(r, r2, skullSprite);
      break;
    }
  }
  while (true)
  {
    r = (int)random(maxGridX);
    r2 = (int)random(maxGridY);

    if (objects[r][r2] == null)
    {
      new Berserker(r, r2, berserkerSprite);
      break;
    }
  }
  while (true)
  {
    r = (int)random(maxGridX);
    r2 = (int)random(maxGridY);

    if (objects[r][r2] == null)
    {
      new Healer(r, r2, healerSprite);
      break;
    }
  }
  while (true)
  {
    r = (int)random(maxGridX);
    r2 = (int)random(maxGridY);

    if (objects[r][r2] == null)
    {
      new Wizard(r, r2, wizardSprite);
      break;
    }
  }
  for (int i = 0; i < random (10, 20); i++)
  {
    while (true)
    {
      r = (int)random(maxGridX);
      r2 = (int)random(maxGridY);

      if (objects[r][r2] == null)
      {
        new Obstacle(r, r2, rock);
        break;
      }
    }
  }
  for (int i = 0; i < random (5, 7); i++)
  {
    remainingEnemies++;
    while (true)
    {
      r = (int)random(maxGridX);
      r2 = (int)random(maxGridY);

      if (objects[r][r2] == null)
      {
        new Enemy(r, r2, demon);
        break;
      }
    }
  }
  for (int i = 0; i < maxGridX; i++)
  {
    for (int j = 0; j < maxGridY; j++)
    {
      if (objects[i][j] == null)
      {
        new GridObject(i, j);
      }
    }
  }
  dialogues[0] = new Dialogue("Long ago, in an age of strife, a fearsome Demon King arose \nand spread terror throughout the land.", "Narrator", narrator);
  dialogues[1] = new Dialogue("None could face his demon army, and all hope seemed lost.", "Narrator", narrator);
  dialogues[2] = new Dialogue("That is, until the benevolent deity Bobaloobi intervened, \nbestowing blessed weapons upon a group of great heroes.", "Narrator", narrator);
  dialogues[3] = new Dialogue("Brave, strong, intelligent, and cunning, these heroes undertook \nan epic crusade against the Demon King and his minions, \nand emerged victorious.", "Narrator", narrator);
  dialogues[4] = new Dialogue("Their task done, these heroes returned home, where they \nwere showered with adoration for their grand deeds, \nand rewarded with all manner of riches.", "Narrator", narrator);
  dialogues[5] = new Dialogue("Time marched on, and with no higher purpose to unite them, \nthe heroes drifted apart and led lavish but mundane lives.", "Narrator", narrator);
  dialogues[6] = new Dialogue("As the memories of their glorious pasts faded, \nso too did their once great minds and bodies.", "Narrator", narrator);
  dialogues[7] = new Dialogue("Rolf, the fearsome warrior, went berserk one time too many, \nand finally crossed the point of no return. \nThe traumas from the difficult battles of his past leaves him \nconstantly fighting a foe only he can see.", "Narrator", narrator);
  dialogues[8] = new Dialogue("Thamina, the once empathetic healer, was filled with a sense of \ndisillusionment and ennui, and ceased to \ncare for herself or others. She spends her days alone, \nlazing about and scowling at passerby.", "Narrator", narrator);
  dialogues[9] = new Dialogue("Copernicus, the kingdom's premier expert on magic in his youth, \ncould not escape from the grasp of time, \nor its decay upon the mind and body. He wanders around \nhis Grand Library, frail and senile.", "Narrator", narrator);
  dialogues[10] = new Dialogue("Ser Ethelred, the noble leader of the heroes, \nmet his end in a fierce struggle between his \nwindpipe and an especially troublesome grape.", "Narrator", narrator);
  dialogues[11] = new Dialogue("Now, the Demon King has returned to power, and these heroes, \nwielders of the divine weapons, must rise once more to face him.", "Narrator", narrator);
  dialogues[12] = new Dialogue("We're screwed.", "Narrator", narrator);
  dialogues[13] = new Dialogue("Heroes! The world needs you once more! Only you can fight the \nencroaching darkness, and free these lands from the \nDemon King's grasp!", "Bobaloobi", bub);
  dialogues[14] = new Dialogue("You know, I'd love to, but I'm already booked solid for this weekend. \nI've got a lot of nihilistic torment to get to, \nso I'm gonna have to give this one a pass.", "Thamina", healerHead);
  dialogues[15] = new Dialogue("You are the wielders of the divine weapons, the only ones capable of \ndefeating the Demon King and saving the world from eternal dark!", "Barabapapa", bub);
  dialogues[16] = new Dialogue("You know, you make a very compelling argument. Tell you what. \nI'll give you your magic staff back and you can \nfind a new chump to do your dirty work.", "Thamina", healerHead);
  dialogues[17] = new Dialogue("Divine weapons aren't scrap to be passed around like second-hand \ntools! They are bound to you, flesh and bone; only you can wield them.", "Barappa the Rappa", bub);
  dialogues[18] = new Dialogue("So find some eager, musclebound, goody-two shoe knuckleheads and \nwhip up some shiny sticks for them. I'm not interested.", "Thamina", healerHead);
  dialogues[19] = new Dialogue("What, do you think I'm MADE of divine weapons?! You think they \ngrow on trees up here? No, you will reunite with your compatriots. \nI will brook no further dissent.", "M. Night Bamalan", bub);
  dialogues[20] = new Dialogue("What compatriots? Rolf's lost it, Copernicus is senile. \nEthelred is DEAD, for your sake!", "Thamina", healerHead);
  dialogues[21] = new Dialogue("AAAAAARRRRRRRGGGGGHHHHHHHHHHHH!!!!!!!!", "Rolf", berserkerHead);
  dialogues[22] = new Dialogue("*wheeze* I never…who’s Copernicus? Where are my slippers? \nMy back hurts. Who were you again?", "Copernicus", wizardHead);
  dialogues[23] = new Dialogue("...", "Ser Ethelred", skullHead);
  dialogues[24] = new Dialogue("You'll work something out, I'm sure.", "Bobaracka Obamaloobi", bub);
  dialogues[25] = new Dialogue("What's the point in even trying? I can't do a thing with a madman, \nan old fart, and a corpse.", "Thamina", healerHead);
  dialogues[26] = new Dialogue("...", "Copernicus", wizardHead);
  dialogues[27] = new Dialogue("Oh, that's just fantastic. 2 corpses.", "Thamina", healerHead);
  dialogues[28] = new Dialogue("GRAGGGHHHHHHHHHHHHH!!!", "Rolf", berserkerHead);
  dialogues[29] = new Dialogue("…! Wha? Who? *cough cough* *wheeze* *old man noises* \nAre we going to the park? I do so love to feed the ducks.", "Copernicus", wizardHead);
  dialogues[30] = new Dialogue("Alright, still one corpse. I'm still not gonna lift a finger.", "Thamina", healerHead);
  dialogues[31] = new Dialogue("Fear not, heroes, you'll not be alone! \nI, Boba Fettaloobi, will be guiding you! \nI shall move the earth itself to bring you to victory.", "Balalalala", bub);
  dialogues[32] = new Dialogue("If you're helping anyway, why not just \nreach down and smite the damned demons?", "Thamina", healerHead);
  dialogues[33] = new Dialogue("Have you ever smote someone before? It's hard work! \nI've got a lot on my plate running the heavens, you know!", "Bananananananana BATMAN", bub);
  dialogues[34] = new Dialogue("In my day, we had to walk to the battlefield. \nUphill! \nBoth ways! *wheeze*", "Copernicus", wizardHead);
  dialogues[35] = new Dialogue("URGHAAAAAA!!!!", "Rolf", berserkerHead);
  dialogues[36] = new Dialogue("...", "Ser Ethelred", skullHead);
  dialogues[37] = new Dialogue("Good, good. it’s settled then. Now, off you go! \nI have to go catch my soaps- \ner, reward the righteous with eternal life. Bye!", "Baby Baby Baby Baby Baby", bub);
  dialogues[38] = new Dialogue("Well, shit. What do we do now?", "Thamina", healerHead);
  noCursor();
}

void draw() 
{
  background(30);
  if (GAME_STATE == 0)
  { 
    if (millis() < 2000)
    {
      tint(255, 0);
    } else if (millis() <= 7100)
    {
      playerWhistle.play();
      tint(255, (millis() - 2000)/20);
    } else if (millis() >= 9100)
    {
      tint(255, (11650-millis())/10);
    }
    image(logo, (width-512)/2, (height-512)/2, 512, 512);
    if (millis() > 13000)
    {
      GAME_STATE++;
    }
  }
  if (GAME_STATE == 1)
  {
    tint(255, n);
    if (n<255)
    {
      n += 10;
    }
    image(heroGroup, 0, 0, width, height);
    image(title, 0, 0, width, height);
    if (mainFade)
    {
      fill(255, mainFadeNum);
      rect(0, 0, width, height);
      mainFadeNum+=10;
      if (mainFadeNum >= 255)
      {
        GAME_STATE++;
        mainFade = false;
      }
    }
  }
  if (GAME_STATE == 2)
  {
    tint(255, 255);
    println(2);
    image(heroGroup2, 0, 0, width, height);
    image(title, 0, 0, width, height);
    image(buttonIntro, width/2 - 233, height/2);
    if (mainMenu == 1)
    {
      tint(0, 125, 0, 200);
      image(buttonIntro, width/2 - 233, height/2);
      tint(255, 255);
    }
    image(buttonPlay, width/2 - 233, height/2 + 100);
    if (mainMenu == 2)
    {
      tint(0, 125, 0, 200);
      image(buttonPlay, width/2 - 233, height/2 + 100);
      tint(255, 255);
    }
    image(buttonCredits, width/2 - 233, height/2 + 200);
    if (mainMenu == 3)
    {
      tint(0, 125, 0, 200);
      image(buttonCredits, width/2 - 233, height/2 + 200);
      tint(255, 255);
    }
    if (mainFadeNum > 0)
    {
      fill(255, mainFadeNum);
      rect(0, 0, width, height);
      mainFadeNum-=10;
    }
  }
  if (GAME_STATE == 3) 
  {
    println(3);
    tint(255, 255);
    if (dIndex >= dialogues.length)
    {
      dIndex = 0;
      GAME_STATE--;
    } else
    {
      dialogues[constrain(dIndex, 0, 38)].draw();
    }
  }
  if (GAME_STATE == 4)
  {
    if (remainingEnemies <= 0)
    {
      GAME_STATE = 7;
    }
    println(4);
    if (!playerSong.isPlaying())
    {
      playerSong.loop(1000);
    }
    tint(255, 255);
    gridSizeX = width/gridX;
    gridSizeY = height/gridY;
    fill(255);
    smooth();
    stroke(0);
    noFill();
    for (int i = 0; i < maxGridX; i++)
    {
      for (int j = 0; j < maxGridY; j++)
      {
        tint(255, 255);
        image(grass, gridSizeX * i - offsetX, gridSizeY * j - offsetY, gridSizeX, gridSizeY);
        if (objects[i][j].sprite != null)
        {
          objects[i][j].draw();
        }
      }
    }
    for (int i = 0; i < maxGridX; i++)
    {
      for (int j = 0; j < maxGridY; j++)
      {
        if (i == selectedGridX || j == selectedGridY)
        {
          if (i == selectedGridX && j == selectedGridY)
          {
            tint(255, 125);
            if (i < maxGridX)
            {
              image(arrowRight, gridSizeX * (i+1) - offsetX, gridSizeY * j - offsetY, gridSizeX, gridSizeY);
            }
            if (i > 0)
            {
              image(arrowLeft, gridSizeX * (i-1) - offsetX, gridSizeY * j - offsetY, gridSizeX, gridSizeY);
            }
            if (j < maxGridY)
            {
              image(arrowDown, gridSizeX * i - offsetX, gridSizeY * (j+1) - offsetY, gridSizeX, gridSizeY);
            }
            if (j > 0)
            {
              image(arrowUp, gridSizeX * i - offsetX, gridSizeY * (j-1) - offsetY, gridSizeX, gridSizeY);
            }
          }
          fill(255, 0, 0, 40);
        } else
        {
          noFill();
        }
        if (mouseX + offsetX > i * gridSizeX && mouseX + offsetX < (i + 1) * gridSizeX && mouseY + offsetY > j * gridSizeY && mouseY + offsetY < (j + 1) * gridSizeY)
        {
          fill(255, 255, 0, 40);
        }
        if (tempGridX == i && tempGridY == j)
        {
          fill(0, 0, 255, 40);
        }
        rect(gridSizeX * i - offsetX, gridSizeY * j - offsetY, gridSizeX, gridSizeY);
      }
    }
    menu.draw();
  }
  if (GAME_STATE == 5)
  {
    tint(255, 255);
    image(credits, 0, 0, width, height);
    if (leaveCredits >= 2)
    {
      GAME_STATE = 2;
      leaveCredits = 0;
    }
  }
  if (GAME_STATE == 6)
  {
    boolean stateBool = true;
    for (int i = 0; i < maxGridX; i++)
    {
      for (int j = 0; j < maxGridY; j++)
      {
        noFill();
        image(grass, gridSizeX * i - offsetX, gridSizeY * j - offsetY, gridSizeX, gridSizeY);
        if (objects[i][j].sprite != null)
        {
          objects[i][j].draw();
        }
        rect(gridSizeX * i - offsetX, gridSizeY * j - offsetY, gridSizeX, gridSizeY);
        if (objects[i][j].movement > 0)
        {
          stateBool = false;
          objects[i][j].movement--;
          if (objects[i][j].movement <= 0)
          {
            objects[i][j].attack();
          }
          int r = (int)random(4);
          if (i + 1 < maxGridX && r == 0 && objects[i+1][j].blank)
          {
            objects[i+1][j] = objects[i][j];
            objects[i][j] = new GridObject(i, j);
            objects[i+1][j].gridPosX++;
          }
          if (j + 1 < maxGridY && r == 1 && objects[i][j+1].blank)
          {
            objects[i][j+1] = objects[i][j];
            objects[i][j] = new GridObject(i, j);
            objects[i][j+1].gridPosY++;
          }
          if (i - 1 >= 0 && r == 2 && objects[i-1][j].blank)
          {
            objects[i-1][j] = objects[i][j];
            objects[i][j] = new GridObject(i, j);
            objects[i-1][j].gridPosX--;
          }
          if (j - 1 >= 0 && r == 3 && objects[i][j-1].blank)
          {
            objects[i][j-1] = objects[i][j];
            objects[i][j] = new GridObject(i, j);
            objects[i][j-1].gridPosY--;
          }
        }
      }
    }
    if (stateBool)
    {
      GAME_STATE = 4;
    }
  }
  if(GAME_STATE == 7)
  {
    textSize(60);
    textAlign(CENTER);
    text("YOU WIN!!!", width/2, height/2);
    textAlign(LEFT);
  }
}

void mouseWheel(MouseEvent event) {
  float fHeight = height;
  float fWidth = width;
  if (event.getCount() > 0)
  {
    if (gridX < maxGridX && gridY < maxGridY)
    {
      gridX++;
      gridY += fHeight/fWidth;
    }
  } else
  {
    if (gridX > 1 && gridY > fHeight/fWidth)
    {
      gridX--;
      gridY -= fHeight/fWidth;
    }
  }
  offsetX = constrain(offsetX, 0, (maxGridX * gridSizeX) - (gridX * gridSizeX));
  offsetY = constrain(offsetY, 0, (maxGridY * gridSizeY) - (gridY * gridSizeY));
}

void keyTyped()
{
  if (GAME_STATE == 2)
  {
    if (key == 's' || key == 'S')
    {
      mainMenu++;
      if (mainMenu <= 3)
      {
        playerBip.play();
        playerBip.rewind();
      }
      mainMenu = constrain(mainMenu, 1, 3);
    }
    if (key == 'w' || key == 'W')
    {
      mainMenu--;
      if (mainMenu>0)
      {
        playerBip.play();
        playerBip.rewind();
      }
      mainMenu = constrain(mainMenu, 1, 3);
    }
  } else if (!menu.isOpen)
  {
    if (key == 'a' || key == 'A')
    {
      offsetX-=15;
    }
    if (key == 'd' || key == 'D')
    {
      offsetX+=15;
    }
    if (key == 's' || key == 'S')
    {
      offsetY += 15;
    }
    if (key == 'w' || key == 'W')
    {
      offsetY -= 15;
    }
    offsetX = constrain(offsetX, 0, (maxGridX * gridSizeX) - (gridX * gridSizeX));
    offsetY = constrain(offsetY, 0, (maxGridY * gridSizeY) - (gridY * gridSizeY));
  } else if (menu.isOpen)
  {
    if (key == 's' || key == 'S')
    {
      menu.selectedOption++;
      if (menu.selectedOption <= 4)
      {
        playerBip.play();
        playerBip.rewind();
      }
    }
    if (key == 'w' || key == 'W')
    {
      menu.selectedOption--;
      if (menu.selectedOption > 0)
      {
        playerBip.play();
        playerBip.rewind();
      }
    }
    menu.selectedOption = constrain(menu.selectedOption, 1, 4);
  }
}

void keyPressed() {
  if ((key == ENTER || key == RETURN))
  {
    if (GAME_STATE == 0)
    {
      GAME_STATE++;
    }
    if (GAME_STATE == 1)
    {
      mainFade = true;
    }
    if (GAME_STATE == 2)
    {
      GAME_STATE += mainMenu;
      playerBew.play();
      playerBew.rewind();
    }
    if (GAME_STATE == 3)
    {
      if (doneText)
      {
        dIndex++;
        doneText = false;
      } else
      {
        dialogues[dIndex].dCount = dialogues[dIndex].text.length();
        doneText = true;
      }
    }
    if (GAME_STATE == 5)
    {
      leaveCredits++;
    }
    if (menu.isOpen)
    {
      if (menu.selectedOption == 1)
      {
        gridSelected = true;
        selectedGridX = tempGridX;
        selectedGridY = tempGridY;
      } else if (menu.selectedOption == 4)
      {
        GAME_STATE = 6;
      }
      playerBew.play();
      playerBew.rewind();
      tempGridX = -1;
      tempGridY = -1;
      menu.isOpen = false;
    }
  }
}

void mouseClicked() {
  if (!menu.isOpen)
  {
    if (gridSelected) 
    {
      destinationX = (int)((mouseX + offsetX)/gridSizeX);
      destinationY = (int)((mouseY + offsetY)/gridSizeY);
      //println("X: " + destinationX + " Y: " + destinationY);
      if (destinationX == selectedGridX && destinationY != selectedGridY)
      {
        GridObject[] tempObjects = new GridObject[(int)maxGridY];
        for (int i = 0; i < maxGridY; i++)
        {
          tempObjects[i] = objects[selectedGridX][i];
        }
        int distance = selectedGridY - destinationY;
        if (abs(distance) <= remainingMoves)
        {
          remainingMoves -= abs(distance);
          int cDis = distance;
          for (int i = 0; i < maxGridY; i++)
          {
            //println("i = " + i);
            cDis = distance + i;
            if (cDis >= maxGridY)
            {
              cDis -= maxGridY;
            } else if (cDis < 0)
            {
              cDis += maxGridY;
            }
            //int print = cDis;
            //println("Index = " + print);
            objects[selectedGridX][i] = tempObjects[cDis];
            objects[selectedGridX][i].gridPosY = i;
            objects[selectedGridX][i].attack();
            objects[selectedGridX][i].special = false;
          }
        }
        for (int i = 0; i < maxGridY; i++)
        {
          if (!objects[selectedGridX][i].special)
          {
            if (distance > 0)
            {
              objects[selectedGridX][i].specialMovement(distance, 3);
            } else if (distance < 0)
            {
              objects[selectedGridX][i].specialMovement(abs(distance), 2);
            }
          }
        }
      } else if (destinationY == selectedGridY && destinationX != selectedGridX)
      {
        GridObject[] tempObjects = new GridObject[(int)maxGridX];
        for (int i = 0; i < maxGridX; i++)
        {
          tempObjects[i] = objects[i][selectedGridY];
        }
        int distance = selectedGridX - destinationX;
        if (abs(distance) <= remainingMoves)
        {
          remainingMoves -= abs(distance);

          int cDis = distance;
          for (int i = 0; i < maxGridX; i++)
          {

            cDis = distance + i;
            if (cDis >= maxGridX)
            {
              cDis -= maxGridX;
            } else if (cDis < 0)
            {
              cDis += maxGridX;
            }
            int print = cDis;
            objects[i][selectedGridY] = tempObjects[cDis];
            objects[i][selectedGridY].gridPosX = i;
            objects[i][selectedGridY].attack();
            objects[i][selectedGridY].special = false;
          }
        }
        for (int i = 0; i < maxGridX; i++)
        {
          if (!objects[i][selectedGridY].special)
          {
            if (distance > 0)
            {
              objects[i][selectedGridY].specialMovement(distance, 1);
            } else if (distance < 0)
            {
              objects[i][selectedGridY].specialMovement(abs(distance), 0);
            }
          }
        }
      }
      if (remainingMoves<=0)
      {
        GAME_STATE = 6;
      }
      selectedGridX = -1;
      selectedGridY = -1;
      gridSelected = false;
    } else 
    {
      tempGridX = (int)((mouseX + offsetX)/gridSizeX);
      tempGridY = (int)((mouseY + offsetY)/gridSizeY);
      menu.isOpen = true;
    }
  }
}


class GridObject {
  int movement;
  int gridPosX;
  int gridPosY;
  int health = 0;
  int damage;
  boolean alive = false;
  PImage sprite;
  boolean enemy = false;
  boolean special = false;
  boolean blank = true;
  boolean calculatedInertia = false;

  GridObject(int x, int y)
  {
    gridPosX = x;
    gridPosY = y;
    //sprite = grass;
    objects[x][y] = this;
  }
  GridObject(int x, int y, PImage z)
  {
    gridPosX = x;
    gridPosY = y;
    sprite = z;
    objects[x][y] = this;
  }
  void specialMovement(int d, int n)
  {
  }
  void attack()
  {
  }
  void draw()
  {
    image(sprite, gridPosX * gridSizeX - offsetX, gridPosY * gridSizeY - offsetY, gridSizeX, gridSizeY);
  }
}

class Obstacle extends GridObject {
  Obstacle(int x, int y)
  {
    super(x, y);
    blank = false;
  }
  Obstacle(int x, int y, PImage z)
  {
    super(x, y, z);
    blank = false;
  }
}

class Unit extends GridObject {
  Unit(int x, int y)
  {
    super(x, y);
    blank = false;
    alive = true;
  }
  Unit(int x, int y, PImage z)
  {
    super(x, y, z);
    blank = false;
    alive = true;
  }
}

class Enemy extends Unit {
  Enemy(int x, int y)
  {
    super(x, y);
    health = 4;
    movement = 6;
  }
  Enemy(int x, int y, PImage z)
  {
    super(x, y, z);
    health = 4;
    movement = 6;
    enemy = true;
  }
  void attack()
  {
    if (gridPosX + 1 < maxGridX)
    {
      objects[gridPosX+1][gridPosY].health -= damage;
      if (objects[gridPosX+1][gridPosY].health <= 0 && objects[gridPosX+1][gridPosY].alive && !objects[gridPosX+1][gridPosY].enemy)
      { 
        objects[gridPosX+1][gridPosY] = new GridObject(gridPosX+1, gridPosY);
      }
    }
    if (gridPosX - 1 >= 0)
    {
      objects[gridPosX-1][gridPosY].health -= damage;
      if (objects[gridPosX-1][gridPosY].health <= 0 && objects[gridPosX-1][gridPosY].alive && !objects[gridPosX-1][gridPosY].enemy)
      {
        objects[gridPosX-1][gridPosY] = new GridObject(gridPosX-1, gridPosY);
      }
    }
    if (gridPosY + 1 < maxGridY)
    {
      objects[gridPosX][gridPosY+1].health -= damage;
      if (objects[gridPosX][gridPosY+1].health <= 0 && objects[gridPosX][gridPosY+1].alive && !objects[gridPosX][gridPosY+1].enemy)
      {
        objects[gridPosX][gridPosY+1] = new GridObject(gridPosX, gridPosY+1);
      }
    }
    if (gridPosY - 1 > 0)
    {
      objects[gridPosX][gridPosY-1].health -= damage;
      if (objects[gridPosX][gridPosY-1].health <= 0 && objects[gridPosX][gridPosY-1].alive && !objects[gridPosX][gridPosY-1].enemy)
      {
        objects[gridPosX][gridPosY-1] = new GridObject(gridPosX, gridPosY-1);
      }
    }
  }
}

class Hero extends Unit
{
  Hero(int x, int y)
  {
    super(x, y);
  }
  Hero(int x, int y, PImage z)
  {
    super(x, y, z);
  }
}

class Berserker extends Hero
{
  Berserker(int x, int y)
  {
    super(x, y);
    health = 5;
    damage = 2;
  }
  Berserker(int x, int y, PImage z)
  {
    super(x, y, z);
    health = 5;
    damage = 2;
  }
  void attack()
  {
    if (gridPosX + 1 < maxGridX)
    {
      objects[gridPosX+1][gridPosY].health -= damage;
      if (objects[gridPosX+1][gridPosY].health <= 0 && objects[gridPosX+1][gridPosY].alive)
      { 
        if (objects[gridPosX+1][gridPosY].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX+1][gridPosY] = new GridObject(gridPosX+1, gridPosY);
      }
    }
    if (gridPosX - 1 >= 0)
    {
      objects[gridPosX-1][gridPosY].health -= damage;
      if (objects[gridPosX-1][gridPosY].health <= 0 && objects[gridPosX-1][gridPosY].alive)
      {
        if (objects[gridPosX-1][gridPosY].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX-1][gridPosY] = new GridObject(gridPosX-1, gridPosY);
      }
    }
    if (gridPosY + 1 < maxGridY)
    {
      objects[gridPosX][gridPosY+1].health -= damage;
      if (objects[gridPosX][gridPosY+1].health <= 0 && objects[gridPosX][gridPosY+1].alive)
      {
        if (objects[gridPosX][gridPosY+1].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX][gridPosY+1] = new GridObject(gridPosX, gridPosY+1);
      }
    }
    if (gridPosY - 1 > 0)
    {
      objects[gridPosX][gridPosY-1].health -= damage;
      if (objects[gridPosX][gridPosY-1].health <= 0 && objects[gridPosX][gridPosY-1].alive)
      {
        if (objects[gridPosX][gridPosY-1].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX][gridPosY-1] = new GridObject(gridPosX, gridPosY-1);
      }
    }
  }
}

class Healer extends Hero
{
  Healer(int x, int y)
  {
    super(x, y);
    health = 3;
    damage = -2;
  }
  Healer(int x, int y, PImage z)
  {
    super(x, y, z);
    health = 3;
    damage = -2;
  }
  void attack()
  {
    if (gridPosX + 1 < maxGridX)
    {
      objects[gridPosX+1][gridPosY].health -= damage;
    }
    if (gridPosX - 1 >= 0)
    {
      objects[gridPosX-1][gridPosY].health -= damage;
    }
    if (gridPosY + 1 < maxGridY)
    {
      objects[gridPosX][gridPosY+1].health -= damage;
    }
    if (gridPosY - 1 >= 0)
    {
      objects[gridPosX][gridPosY-1].health -= damage;
    }
  }
}

class Wizard extends Hero
{
  Wizard(int x, int y)
  {
    super(x, y);
    health = 3;
    damage = 4;
  }
  Wizard(int x, int y, PImage z)
  {
    super(x, y, z);
    health = 3;
    damage = 4;
  }
  void attack()
  {
    if (gridPosX + 1 < maxGridX && gridPosY + 1 < maxGridY && random(10)> 7)
    {
      objects[gridPosX+1][gridPosY+1].health -= damage;
      if (objects[gridPosX+1][gridPosY+1].health <= 0 && objects[gridPosX+1][gridPosY+1].alive)
      { 
        if (objects[gridPosX+1][gridPosY+1].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX+1][gridPosY+1] = new GridObject(gridPosX+1, gridPosY+1);
      }
    }
    if (gridPosX - 1 >= 0 && gridPosY + 1 < maxGridY && random(10)> 4)
    {
      objects[gridPosX-1][gridPosY+1].health -= damage;
      if (objects[gridPosX-1][gridPosY+1].health <= 0 && objects[gridPosX-1][gridPosY+1].alive)
      { 
        if (objects[gridPosX-1][gridPosY+1].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX-1][gridPosY+1] = new GridObject(gridPosX-1, gridPosY+1);
      }
    }
    if (gridPosY + 1 < maxGridY && random(10)> 5)
    {
      objects[gridPosX][gridPosY+1].health -= damage;
      if (objects[gridPosX][gridPosY+1].health <= 0 && objects[gridPosX][gridPosY+1].alive)
      { 
        if (objects[gridPosX][gridPosY+1].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX][gridPosY+1] = new GridObject(gridPosX, gridPosY+1);
      }
    }
    if (gridPosY - 1 >= 0 && random(10)> 5)
    {
      objects[gridPosX][gridPosY-1].health -= damage;
      if (objects[gridPosX][gridPosY-1].health <= 0 && objects[gridPosX][gridPosY-1].alive)
      { 
        if (objects[gridPosX][gridPosY-1].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX][gridPosY-1] = new GridObject(gridPosX, gridPosY-1);
      }
    }
    if (gridPosX + 1 < maxGridX && random(10)> 5)
    {
      objects[gridPosX+1][gridPosY].health -= damage;
      if (objects[gridPosX+1][gridPosY].health <= 0 && objects[gridPosX+1][gridPosY].alive)
      { 
        if (objects[gridPosX+1][gridPosY].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX+1][gridPosY] = new GridObject(gridPosX+1, gridPosY);
      }
    }
    if (gridPosX - 1 >= 0 && random(10)> 5)
    {
      objects[gridPosX-1][gridPosY].health -= damage;
      if (objects[gridPosX-1][gridPosY].health <= 0 && objects[gridPosX-1][gridPosY].alive)
      { 
        if (objects[gridPosX-1][gridPosY].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX-1][gridPosY] = new GridObject(gridPosX-1, gridPosY);
      }
    }
    if (gridPosX + 2 < maxGridX && random(10)> 5)
    {
      objects[gridPosX+2][gridPosY].health -= damage;
      if (objects[gridPosX+2][gridPosY].health <= 0 && objects[gridPosX+2][gridPosY].alive)
      { 
        if (objects[gridPosX+2][gridPosY].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX+2][gridPosY] = new GridObject(gridPosX+2, gridPosY);
      }
    }
    if (gridPosX - 2 >= 0 && random(10)> 5)
    {
      objects[gridPosX-2][gridPosY].health -= damage;
      if (objects[gridPosX-2][gridPosY].health <= 0 && objects[gridPosX-2][gridPosY].alive)
      { 
        if (objects[gridPosX-2][gridPosY].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX-2][gridPosY] = new GridObject(gridPosX-2, gridPosY);
      }
    }
    if (gridPosY + 2 < maxGridY && random(10)> 5)
    {
      objects[gridPosX][gridPosY+2].health -= damage;
      if (objects[gridPosX][gridPosY + 2].health <= 0 && objects[gridPosX][gridPosY+2].alive)
      { 
        if (objects[gridPosX][gridPosY+2].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX][gridPosY+2] = new GridObject(gridPosX, gridPosY+2);
      }
    }
    if (gridPosY - 2 >= 0 && random(10)> 5)
    {
      objects[gridPosX][gridPosY-2].health -= damage;
      if (objects[gridPosX][gridPosY-2].health <= 0 && objects[gridPosX][gridPosY-2].alive)
      { 
        if (objects[gridPosX][gridPosY-2].movement == 6)
        {
          remainingEnemies--;
        }
        objects[gridPosX][gridPosY-2] = new GridObject(gridPosX, gridPosY-2);
      }
    }
  }
}

class WheelKnight extends Hero
{
  WheelKnight(int x, int y)
  {
    super(x, y);
    health = 4;
  }
  WheelKnight(int x, int y, PImage z)
  {
    super(x, y, z);
    health = 4;
  }
  void specialMovement(int d, int n)
  {
    if (d >= 2)
    {
      int tempPlusX = gridPosX;
      int tempPlusY = gridPosY;
      int tempMinusX = gridPosX;
      int tempMinusY = gridPosY;

      tempPlusX = gridPosX + 1;
      tempPlusY = gridPosY + 1;
      tempMinusX = gridPosX - 1;
      tempMinusY = gridPosY - 1;

      if (tempPlusX >= maxGridX)
      {
        tempPlusX -= maxGridX;
      }
      if (tempPlusY >= maxGridY)
      {
        tempPlusY -= maxGridY;
      }
      if (tempMinusX < 0)
      {
        tempMinusX += maxGridX;
      }
      if (tempMinusY < 0)
      {
        tempMinusY += maxGridY;
      }
      if (n == 0 && (objects[tempPlusX][gridPosY].blank || objects[tempPlusX][gridPosY].alive))
      {
        objects[tempPlusX][gridPosY] = this;
        objects[gridPosX][gridPosY] = new GridObject(gridPosX, gridPosY);
        this.gridPosX = tempPlusX;
      }
      if (n == 1 && (objects[tempMinusX][gridPosY].blank || objects[tempMinusX][gridPosY].alive))
      {
        objects[tempMinusX][gridPosY] = this;
        objects[gridPosX][gridPosY] = new GridObject(gridPosX, gridPosY);
        this.gridPosX = tempMinusX;
      }
      if (n == 2 && (objects[gridPosX][tempPlusY].blank || objects[gridPosX][tempPlusY].alive))
      {
        objects[gridPosX][tempPlusY] = this;
        objects[gridPosX][gridPosY] = new GridObject(gridPosX, gridPosY);
        this.gridPosY = tempPlusY;
      }
      if (n == 3 && (objects[gridPosX][tempMinusY].blank || objects[gridPosX][tempMinusY].alive))
      {
        objects[gridPosX][tempMinusY] = this;
        objects[gridPosX][gridPosY] = new GridObject(gridPosX, gridPosY);
        this.gridPosY = tempMinusY;
      }
      special = true;
    }
  }
}

class Dialogue {
  PImage speakerPic;
  String text;
  String tempText;
  String speakerName;
  boolean tick = true;
  int dCount = 1;
  int loopCount = 0;

  Dialogue()
  {
  }

  Dialogue(String t, String n, PImage s)
  {
    text = t;
    speakerName = n;
    speakerPic = s;
  }

  void draw()
  {
    tempText = text.substring(0, dCount);
    if (tick)
    {
      playerTick.play();
      playerTick.rewind();
      tick = false;
    }
    image(headBack, 0, (int)(height * 2 / 3), (int)(height/3), (int)(height/3));
    image(speakerPic, 0, (int)(height * 2 / 3), (int)(height/3), (int)(height/3));
    image(headBox, 0, (int)(height * 2 / 3), (int)(height/3), (int)(height/3));
    image(textBack, (int)(height/3), (int)(height * 2 / 3), (int)(width - height/3), (int)(height/3));
    image(textBox, (int)(height/3), (int)(height * 2 / 3), (int)(width - height/3), (int)(height/3));
    textSize(20);
    fill(255);
    text(speakerName, (int)(height/3 + height/20), (int)(height * 2 / 3 + height/22));
    textSize(30);
    fill(0);
    text(tempText, (int)(height/3 + height/20), (int)(height * 2 / 3 + height/10));
    loopCount++;
    if (loopCount % constrain(((60/(text.length()))), 1, 60) == 0)
    {
      if (dCount<text.length())
      {
        dCount++;
        playerTick.play();
        playerTick.rewind();
      } else
      {
        doneText = true;
      }
    }
    if (doneText)
    {
      textSize(20);
      text("ENTER", width - width/9, height - height/20);
    }
  }
}

class Menu
{
  boolean isOpen = false;
  int selectedOption = 1;
  Menu()
  {
  }
  void draw()
  {
    if (isOpen)
    {
      if (mouseX > 80 && mouseX < 220 && mouseY > 80 && mouseY < 280)
      {
        fill(100, 50);
        stroke(255, 50);
        rect(100, 100, 100, 120, 20);
        fill(255, 50);
      } else
      {
        fill(100);
        stroke(255);
        rect(100, 100, 100, 120, 20);
        fill(255);
      }
      textSize(16);
      text("Shift", 115, 135);
      text("Info", 115, 155);
      text("Cancel", 115, 175);
      text("End Turn", 115, 195);
      //text("End Turn", 115, 215);
      //text("Option 6", 115, 235);
      triangle(185, 110 + 20 * selectedOption, 195, 105 + 20* selectedOption, 195, 115 + 20 * selectedOption);
    }
  }
}

